function AN=normal(A)
% function AN=normal(A)
% P.Comon, 17 June, 1998
% presentation d'une matrice 2x3 sous une forme normalisee,
% arbitraire mais systematique

[m,n]=size(A);

%%% CLASSEMENT DES COLONNES PAR abs(A(1,:)/A(2,:)) CROISSANT %%%
[toto,I]=sort(abs(A(1,:)./(eps+A(2,:))));
AN=A(:,I);

%%% DANS CHAQUE COLONNE, MISE A 1 DU PLUS GRAND ELEMENT %%%
for j=1:n,
  [Am,i]=max(abs(AN(:,j)));
  I=find(abs(AN(:,j))==Am);
  if length(I)==1, AN(:,j)=AN(:,j)/AN(I,j);
  else
  % s'il y en a plusieurs, on choisit celui de Re la plus grande
  [Ar,i]=max(real(AN(I,j)));AN(:,j)=AN(:,j)/AN(i,j);
  end;
  % s'il y en a encore plusieurs, ce sera donc le premier
end;
